// 004 u_c_border_decorator_9
// 17 oct 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   John COLIBRI  http://www.jcolibri.com

(*$r+*)

unit u_c_border_decorator_9;
  interface
    uses u_c_visual_component_9
        , u_c_decorator_9;

    type c_border_decorator= class(c_decorator)
                               _m_border_width: Integer;

                               Constructor create_border_decorator(p_c_visual_component: c_visual_component;
                                   p_border_width: Integer);
                               procedure draw; Override;
                               procedure resize; Override;

                               procedure _draw_border(p_border_width: Integer);

                               Destructor Destroy; Override;
                             end; // c_border_decorator

  implementation

    // -- c_border_decorator

    Constructor c_border_decorator.create_border_decorator(p_c_visual_component: c_visual_component;
        p_border_width: Integer);
      begin
        Inherited create_decorator(p_c_visual_component);
        _m_border_width:= p_border_width;
      end; // create_border_decorator

    procedure c_border_decorator.draw;
      begin
        Inherited draw;
        _draw_border(_m_border_width);
      end; // draw

    procedure c_border_decorator._draw_border(p_border_width: Integer);
      begin
      end; // _draw_border

    procedure c_border_decorator.resize;
      begin
        Inherited resize;

        // -- assume "resize" halves the size
        _m_border_width:= _m_border_width div 2;
        // -- todo: resize the border
        _draw_border(_m_border_width);
      end; // resize

    Destructor c_border_decorator.Destroy;
      begin
        Inherited;
      end; // Destroy

    begin // u_c_decorator
    end. // u_c_decorator
