// 004 u_c_decorator_9
// 17 oct 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   John COLIBRI  http://www.jcolibri.com

(*$r+*)

unit u_c_decorator_9;
  interface
    uses u_c_visual_component_9;

    type // -- abstract in the book schema
         c_decorator= class(c_visual_component)
                        _m_c_visual_component: c_visual_component;

                        Constructor create_decorator(p_c_visual_component: c_visual_component);
                        procedure draw; Override;
                        procedure resize; Override;
                        Destructor Destroy; Override;
                      end; // c_decorator

  implementation

    // -- c_decorator

    Constructor c_decorator.create_decorator(p_c_visual_component: c_visual_component);
      begin
        Inherited Create;
        _m_c_visual_component:= p_c_visual_component;
      end; // create_decorator

    procedure c_decorator.draw;
      begin
        _m_c_visual_component.draw;
      end; // draw

    procedure c_decorator.resize;
      begin
        _m_c_visual_component.resize;
      end; // resize

    Destructor c_decorator.Destroy;
      begin
        Inherited;
      end; // Destroy

    begin // u_c_decorator
    end. // u_c_decorator
