// 004 u_c_scroll_decorator_9
// 17 oct 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   John COLIBRI  http://www.jcolibri.com

(*$r+*)

unit u_c_scroll_decorator_9;
  interface
    uses u_c_visual_component_9
        , u_c_decorator_9;

    type c_scroll_decorator= class(c_decorator)
                               _m_scroll_position: Integer;

                               Constructor create_scroll_decorator(p_c_visual_component: c_visual_component;
                                   p_scroll_position: Integer);
                               procedure draw; Override;
                               procedure resize; Override;

                               procedure draw_scroll(p_scroll_position: Integer);

                               Destructor Destroy; Override;
                             end; // c_scroll_decorator

  implementation

    // -- c_scroll_decorator

    Constructor c_scroll_decorator.create_scroll_decorator(p_c_visual_component: c_visual_component;
        p_scroll_position: Integer);
      begin
        Inherited create_decorator(p_c_visual_component);
        _m_scroll_position:= p_scroll_position;
      end; // create_scroll_decorator

    procedure c_scroll_decorator.draw;
      begin
        Inherited draw;
        draw_scroll(_m_scroll_position);
      end; // draw

    procedure c_scroll_decorator.draw_scroll(p_scroll_position: Integer);
      begin
      end; // draw_scroll

    procedure c_scroll_decorator.resize;
      begin
        Inherited resize;
        // -- todo: resize the scroll
        draw_scroll(_m_scroll_position);
      end; // resize

    Destructor c_scroll_decorator.Destroy;
      begin
        Inherited;
      end; // Destroy

    begin // u_c_decorator
    end. // u_c_decorator
