// 004 u_c_window_9
// 17 oct 2004

// -- Delphi implementation from the book:
// --   Design Patterns Elements of Reusable Object-Oriented Software
// --   Addison Wesley - 1994 - ISBN 0-201-63361-2
// -- (C) Erich GAMMA, Richard HELM, Ralph JOHNSON, John VLISSIDES 1994

// -- translation from C to Delphi performed by
// --   John COLIBRI  http://www.jcolibri.com

(*$r+*)

unit u_c_window_9;
  interface
    uses Windows, Graphics
        , u_c_visual_component_9;

    type c_window= class
                     Constructor create_window;

                     procedure set_contents(p_c_visual_component: c_visual_component);

                     procedure draw_contents; Virtual;
                     procedure open; Virtual;
                     procedure close; Virtual;
                     procedure iconify; Virtual;
                     procedure de_iconify; Virtual;
                     procedure set_origin(p_point: tPoint); Virtual;
                     procedure set_exten(p_extent: tPoint); Virtual;
                     procedure move_up; Virtual;
                     procedure move_down; Virtual;

                     procedure draw_line(p_start_point, p_end_point: tPoint); Virtual;
                     procedure draw_rectangle(p_upper_left, p_lower_right: tPoint); Virtual;
                     procedure draw_polygon(p_oa_points: Array of tPoint); Virtual;
                     procedure draw_text(p_text: String; p_position: tPoint); Virtual;

                     Destructor Destroy; Override;
                   end; // c_window

  implementation

    // -- c_window

    Constructor c_window.create_window;
      begin
        Inherited Create;
      end; // create_window

    procedure c_window.set_contents(p_c_visual_component: c_visual_component);
      begin
      end; // set_contents

    procedure c_window.draw_contents;
      begin
      end; // draw_contents

    procedure c_window.open;
      begin
      end; // open

    procedure c_window.close; 
      begin
      end; // close

    procedure c_window.iconify; 
      begin
      end; // iconify

    procedure c_window.de_iconify;
      begin
      end; // de_iconify

    procedure c_window.set_origin(p_point: tpoint); 
      begin
      end; // set_origin

    procedure c_window.set_exten(p_extent: tpoint);
      begin
      end; // set_exten

    procedure c_window.move_up;
      begin
      end; // move_up

    procedure c_window.move_down;
      begin
      end; // move_down

    procedure c_window.draw_line(p_start_point, p_end_point: tpoint);
      begin
      end; // draw_line

    procedure c_window.draw_rectangle(p_upper_left, p_lower_right: tpoint);
      begin
      end; // draw_rectangle

    procedure c_window.draw_polygon(p_oa_points: array of tpoint);
      begin
      end; // draw_polygon

    procedure c_window.draw_text(p_text: string; p_position: tpoint); 
      begin
      end; // draw_text

    Destructor c_window.Destroy;
      begin
        Inherited;
      end; // Destroy


    begin // u_c_window
    end. // u_c_window
